Home » Python » How to use “raise” keyword in Python

How to use “raise” keyword in Python

Posted by: admin November 1, 2017 Leave a comment

Questions:

I have read the official definition of “raise”, but I still don’t quite understand what it does.

In simplest terms, what is “raise”?

Example usage would help.

Answers:

It has 2 purposes.

yentup has given the first one.

It’s used for raising your own errors.

if something:
    raise Exception('My error!')

The second is to reraise the current exception in an exception handler, so that it can be handled further up the call stack.

try:
  generate_exception()
except SomeException as e:
  if not can_handle(e):
    raise
  handle_exception(e)

Questions:
Answers:

It’s used for raising errors.

if something:
    raise Exception('My error!')

Some examples here

Questions:
Answers:

raise without any arguments is a special use of python syntax. It means get the exception and re-raise it. If this usage it could have been called reraise.

    raise

From The Python Language Reference:

If no expressions are present, raise re-raises the last exception that
was active in the current scope.

If raise is used alone without any argument is strictly used for reraise-ing. If done in the situation that is not at a reraise of another exception, the following error is shown:
RuntimeError: No active exception to reraise

Questions:
Answers:

You can use it to raise errors as part of error-checking:

if (a < b):
    raise ValueError()

Or handle some errors, and then pass them on as part of error-handling:

try:
    f = open('file.txt', 'r')
except IOError:
    # do some processing here
    # and then pass the error on
    raise

Questions:
Answers:

raise causes an exception to be raised. Some other languages use the verb ‘throw’ instead.

It’s intended to signal an error situation; it flags that the situation is exceptional to the normal flow.

Raised exceptions can be caught again by code ‘upstream’ (a surrounding block, or a function earlier on the stack) to handle it, using a try, except combination.

Questions:
Answers:

Besides raise Exception("message") and raise Python 3 introduced a new form, raise Exception("message") from e. It’s called exception chaining, it allows you to preserve the original exception (the root cause) with its traceback.

It’s very similar to inner exceptions from C#.

More info:
https://www.python.org/dev/peps/pep-3134/

Questions:
Answers:

when writing a main program for yourself, it is easier to use an assert statement, but if you are writing a header file, a raise statement generally is more explanatory, as you can raise your own kind of exception.